import fastify = require('fastify')
import { IPlat } from 'plats/IPlat'
import { PlatWechat } from 'plats/PlatWechat'
import { PlatWePage } from 'plats/PlatWePage'
import { PlatAliPayPage } from 'plats/PlatAliPayPage'
import { PlatVivoNative } from 'plats/PlatVivoNative'
import { PlatInfo } from 'models/AppInfo'
import { PlatOppoNative } from 'plats/PlatOppoNative'

class BaseController {
  aotoRoute(req: fastify.FastifyRequest, res) {}

  parsePlat(platInfo: PlatInfo): IPlat | null {
    switch (platInfo.platId) {
      case '1001':
        return new PlatWechat(platInfo)
      case '1002':
        return new PlatWechat(platInfo)
      case '2001':
        return new PlatWePage(platInfo)
      case '2002':
        return new PlatAliPayPage(platInfo)
      case '3002':
        return new PlatVivoNative(platInfo)
      case '3003':
        return new PlatOppoNative(platInfo)
      default:
        return null
    }
  }
}
export default BaseController
