import { singleton } from '../decorators/singleton'
import { compound_vo } from './parsers/compound_vo'

@singleton
export class GameEnv {
  // PVP每题可用时间
  public pvpInterval: number
  // PVP当前连击数的分
  public pvpComboRate: number
  // PVP剩余时间分
  public pvpTimeRate: number
  // PVP答对基础分
  public pvpBaseScore: number

  // 特效播放时间
  public effectTimeLong: number

  // 单人血量分
  public singleHpRate: number
  // 单人最大连击数的分
  public singleComboRate: number
  // 单人剩余时间分
  public singleTimeRate: number
  // 单人降低难度后的得分折扣
  public singleLowLvlRate: number

  public init(data: Map<number, compound_vo>) {
    this.pvpInterval = +data.get(99018).value
    this.pvpComboRate = +data.get(99017).value
    this.pvpTimeRate = +data.get(99016).value
    this.pvpBaseScore = +data.get(99015).value
    this.effectTimeLong = +data.get(99025).value
    this.singleHpRate = +data.get(99002).value
    this.singleComboRate = +data.get(99004).value
    this.singleTimeRate = +data.get(99003).value
    this.singleLowLvlRate = +data.get(99005).value
  }

  /**
   * pvp模式下每题之间的间隔
   * @return {number}
   */
  public get pvpQuestionInterval() {
    return (this.pvpInterval + this.effectTimeLong) * 1000
  }
}
