import { ZError } from 'common/ZError'
import { FlowInstance } from 'models/flow/FlowInstance'
import { ChainSvr } from 'services/ChainSvr'
import { IAction } from './base/IAction'
/**
 * let data = {
      taskId: 111,
      type: 3,
      data: [{ address: '0xb592244aa6477eBDDc14475aaeF921cdDcC0170f', amount: 1000 }],
    }
    new ChainSvr().addTask(data)
 */
export default class implements IAction {
  async execute(id: string) {
    let record = await FlowInstance.findById(id)
    if (!record) {
      throw new ZError(10, 'no record found')
    }
    let datas: IData[] = []
    for (let sub of record.flowData.records) {
      datas.push({
        address: sub.address,
        amount: sub.amount,
      })
    }
    let reqData = {
      taskId: id,
      type: 3,
      data: datas,
    }
    return new ChainSvr().addTask(reqData)
  }
}

interface IData {
  address: string
  amount: number
}
