import { ChainSvr } from 'services/ChainSvr'
import { IAction } from './base/IAction'
import { FlowInstance, FlowStatus, FlowTask } from 'models/flow/FlowInstance'
import { ZError } from 'common/ZError'

export default class implements IAction {
  async execute(id: string) {
    let record = await FlowInstance.findById(id)
    if (!record) {
      throw new ZError(10, 'no record found')
    }
    let datas: IData[] = []
    for (let sub of record.flowData.records) {
      datas.push({
        address: sub.address,
        to: sub.to,
        tokenId: sub.tokenid,
        nftType: sub.nfttype,
      })
    }
    let reqData = {
      taskId: id,
      type: 9,
      data: datas,
    }
    return new ChainSvr().addTask(reqData)
  }
}

interface IData {
  address: string
  to: string
  tokenId: string
  nftType: string
}
