import { ZError } from 'common/ZError'
import { FlowInstance } from 'models/flow/FlowInstance'
import { ChainSvr } from 'services/ChainSvr'
import { IAction } from './base/IAction'
/**
 * let data = {
      taskId: '1',
      type: 7,
      data: [
        {
          address: '0xb592244aa6477eBDDc14475aaeF921cdDcC0170f',
          from: '',
          to: '0x90F8bf6A479f320ead074411a4B0e7944Ea8c9C1',
          amount: 1000,
        },
      ],
    }
 */
export default class implements IAction {
  async execute(id: string) {
    let record = await FlowInstance.findById(id)
    if (!record) {
      throw new ZError(10, 'no record found')
    }
    let datas: IData[] = []
    for (let sub of record.flowData.records) {
      datas.push({
        address: sub.address,
        from: sub.from,
        to: sub.to,
        amount: sub.amount,
      })
    }
    let reqData = {
      taskId: id,
      type: 7,
      data: datas,
    }
    return new ChainSvr().addTask(reqData)
  }
}

interface IData {
  address: string
  from: string
  to: string
  amount: number
}
