import { ZError } from 'common/ZError'
import { FlowInstance } from 'models/flow/FlowInstance'
import { ChainSvr } from 'services/ChainSvr'
import { IAction } from './base/IAction'

/**
 * let data = {
      taskId: '10010',
      type: 6,
      data: [
        {
          address: '0xd45A464a2412A2f83498d13635698a041b9dBe9b',
          to: '0x90F8bf6A479f320ead074411a4B0e7944Ea8c9C1',
          tokenId: '3',
        },
      ],
    }
 */
export default class implements IAction {
  async execute(id: string) {
    let record = await FlowInstance.findById(id)
    if (!record) {
      throw new ZError(10, 'no record found')
    }
    let datas: IData[] = []
    for (let sub of record.flowData.records) {
      datas.push({
        address: sub.address,
        to: sub.to,
        tokenId: sub.tokenid,
      })
    }
    let reqData = {
      taskId: id,
      type: 6,
      data: datas,
    }
    return new ChainSvr().addTask(reqData)
  }
}

interface IData {
  address: string
  to: string
  tokenId: string
}
