import { dbconn } from '../decorators/dbconn'
import { getModelForClass, index, modelOptions, prop } from '@typegoose/typegoose'
import { Severity } from '@typegoose/typegoose/lib/internal/constants'
import { BaseModule } from './Base'

@dbconn()
@index({ status: 1 }, { unique: false })
@modelOptions({
  schemaOptions: { collection: 'audit_task', timestamps: true },
  options: { allowMixed: Severity.ALLOW },
})
export class AuditTaskClass extends BaseModule {
  @prop()
  public tableName: string
  @prop({ type: () => [String] })
  public ids: string[]

  @prop({ default: 0 })
  public status: number

  @prop({ default: 0 })
  public processNum: number

  @prop({ default: 0 })
  public failNum: number

  public static async addOneTask(tableName: string, datas: string[]) {
    let record = new AuditTask({})
    record.tableName = tableName
    record.ids = datas
    await record.save()
    return record._id
  }
}

export const AuditTask = getModelForClass(AuditTaskClass, { existingConnection: AuditTaskClass.db })
