import { getModelForClass, modelOptions, mongoose, plugin, prop } from '@typegoose/typegoose'
import { dbconn } from '../decorators/dbconn'
// @ts-ignore
import findOrCreate from 'mongoose-findorcreate'
import { Severity } from '@typegoose/typegoose/lib/internal/constants'
import { FindOrCreate } from '@typegoose/typegoose/lib/defaultClasses'

@dbconn()
@plugin(findOrCreate)
@modelOptions({
  schemaOptions: { collection: 'file_upload_history', timestamps: true },
  options: { allowMixed: Severity.ALLOW },
})
class FileHistoryClass extends FindOrCreate {
  @prop()
  public _id: string
  @prop()
  public name: string
  @prop()
  public user?: string
  @prop()
  public mimetype: string
  @prop()
  public fileExt: string
  @prop()
  public localPath: string
  @prop({ type: mongoose.Schema.Types.Mixed })
  public reqInfo: any
  @prop({ default: true })
  public isFirst: boolean
}

export const FileHistory = getModelForClass(FileHistoryClass, { existingConnection: FileHistoryClass['db'] })
