import { getModelForClass, modelOptions, prop } from '@typegoose/typegoose'
import { dbconn } from '../decorators/dbconn'

@dbconn()
@modelOptions({ schemaOptions: { collection: 'plat_info', timestamps: true } })
class PlatClass {
  @prop()
  public _id: string
  @prop()
  public name: string
  @prop()
  public comment?: string
}

export const PlatCfg = getModelForClass(PlatClass, { existingConnection: PlatClass['db'] })
