import { dbconn } from '../decorators/dbconn'
import { getModelForClass, index, modelOptions, prop } from '@typegoose/typegoose'
import { BaseModule } from './Base'

@dbconn()
@index({ name: 1 }, { unique: false })
@modelOptions({ schemaOptions: { collection: 'tags' } })
class TagClass extends BaseModule {
  @prop({ required: true })
  public name!: string
}

export const Tag = getModelForClass(TagClass, { existingConnection: TagClass.db })
