import { dbconn } from '../../decorators/dbconn'
import { getModelForClass, modelOptions, mongoose, prop, Ref } from '@typegoose/typegoose'
import { AdminClass } from './Admin'
import { Severity } from '@typegoose/typegoose/lib/internal/constants'
import { BaseModule } from '../Base'

/**
 * 管理员操作记录
 */
@dbconn()
@modelOptions({ schemaOptions: { collection: 'admin_log', timestamps: true }, options: { allowMixed: Severity.ALLOW } })
class AdminLogClass extends BaseModule {
  @prop({ ref: 'AdminClass' })
  public admin: Ref<AdminClass>
  @prop()
  public name: string
  @prop()
  public method: string
  @prop()
  public path: string
  @prop()
  public referer: string
  @prop()
  public user_agent: string
  @prop()
  public ip: string
  @prop({ type: mongoose.Schema.Types.Mixed })
  public params: any
}
export const AdminLog = getModelForClass(AdminLogClass, { existingConnection: AdminLogClass['db'] })
