import { getModelForClass, index, modelOptions, pre, prop } from '@typegoose/typegoose'
import { dbconn } from 'decorators/dbconn'
import { noJson } from 'decorators/nojson'
import { BaseModule } from '../Base'

/**
 * 流程分类
 */
@dbconn()
@modelOptions({ schemaOptions: { collection: 'flow_category', timestamps: true } })
class FlowCategoryClass extends BaseModule {
  @prop({ required: true })
  public name!: string
  @prop({ required: true, default: 999 })
  public sort: number

  /**
   * 是否删除
   * @type {boolean}
   */
  @noJson()
  @prop({ default: false })
  public deleted: boolean
  @noJson()
  @prop()
  public deleteTime: Date

  /**
   * 创建人
   * @type {string}
   */
  @prop()
  public createdBy: string
}

export const FlowCategory = getModelForClass(FlowCategoryClass, { existingConnection: FlowCategoryClass['db'] })
