import { PlatInfo } from '../models/AppInfo'

export interface IPlatData {
  code: string
  needUInfo?: boolean
  token?: string
}
export interface IPlatUser {
  openid: string
  unionid?: string
  sessionKey?: string
  nickname?: string
  headimgurl?: string
  sex?: string
  country?: string
  province?: string
  city?: string
}
export interface IPlat {
  codeToSession(data: IPlatData): Promise<IPlatUser>
  getAuthorizeURL?(scope: string, cbUrl: string, state: string): string
  /**
   * 获取预下单信息
   * @param platInfo  平台信息
   * @param data
   * @return data 预下单完整信息
   */
  preOrder?(platInfo: PlatInfo, data: any): any

  /**
   * 检查支付结果
   * @param req
   * @param res
   */
  checkPayCallback?(req: any, res: any): any
}
