import { IPlat, IPlatUser } from './IPlat'
import { NetClient } from '../net/NetClient'

const netClient = new NetClient()

export class PlatWechat implements IPlat {
  platAppId: string
  platSecret: string
  constructor({ platAppId, platSecret }) {
    this.platAppId = platAppId
    this.platSecret = platSecret
  }
  codeToSession({ code }): Promise<IPlatUser> {
    const link = `https://api.weixin.qq.com/sns/jscode2session?appid=${this.platAppId}&secret=${this.platSecret}&js_code=${code}&grant_type=authorization_code`
    return netClient.httpGet(link).then(res => {
      if (res.data && !res.data.errcode) {
        const openid = res.data.openid
        const unionid = res.data.unionid
        const sessionKey = res.data.session_key
        return { openid, unionid, sessionKey }
      }
    })
  }
}
