import { singleton } from '../decorators/singleton'

/**
 * 自增id的初始值
 * @type {number}
 */
export const INIT_KEY_NUM = 10000
/**
 * 用于生成自增id
 * 需要在服务启动时, 调用init方法, 将现有表的数据放入keyMap中
 */
@singleton
export class MongoTool {
  private keyMap: Map<string, number> = new Map()

  public init(name: string, current: number) {
    this.keyMap.set(name, current)
  }

  public getUniqueKey(name: string): number {
    return this.keyMap.inc(name, 1)
  }
}
