import axios from 'axios'
const iconv = require('iconv-lite')
const cheerio = require('cheerio')

export async function queryKey(str: string) {
  let url = 'https://m.sheup.net/m/info_tiku_2.php'
  let gbkBuffer = iconv.encode(str, 'gb2312')
  let tempStr = ''
  for (let i = 0; i < gbkBuffer.length; i++) {
    tempStr += '%' + gbkBuffer[i].toString(16)
  }
  let searchData = `search_key=${tempStr.toUpperCase()}`
  let reqConfig = {
    method: 'post',
    url,
    headers: {
      'Content-Type': 'application/x-www-form-urlencoded',
      Referer: 'https://m.sheup.net/m/info_tiku_3.php?id=18674&s=1238609075',
      Cookie:
        'UM_distinctid=17906df2e9cadb-017c04b723193d-11114659-1fa400-17906df2e9d22f; CNZZDATA1254461403=1890486453-1619315531-%7C1619315531',
    },
    responseType: 'arraybuffer',
    data: searchData,
  }
  // @ts-ignore
  const res = await axios(reqConfig)
  let html = iconv.decode(res.data, 'gb2312')
  const $ = cheerio.load(html, { decodeEntities: false })
  const $list = $('.li_b')
  let results = []
  for (let s of $list) {
    // console.log($(s).find('a').text())
    // console.log($(s).find('a').attr('href'))
    const subUrl = $(s).find('a').attr('href')
    results.push(await getDetail(subUrl))
  }
  return results
}

export async function getDetail(suburl: string) {
  const url = `https://m.sheup.net/m/${suburl}`
  let reqConfig = {
    method: 'get',
    url,
    headers: {
      'Content-Type': 'application/x-www-form-urlencoded',
      Referer: 'https://m.sheup.net/m/info_tiku_3.php?id=18674&s=1238609075',
      Cookie:
        'UM_distinctid=17906df2e9cadb-017c04b723193d-11114659-1fa400-17906df2e9d22f; CNZZDATA1254461403=1890486453-1619315531-%7C1619315531',
    },
    responseType: 'arraybuffer',
  }
  // @ts-ignore
  const res = await axios(reqConfig)
  let html = iconv.decode(res.data, 'gb2312')
  const $ = cheerio.load(html, { decodeEntities: false })
  let result: any = {}
  const title = $('.ab1_title').text()
  result.title = title.trimStart().trimEnd()
  const sp = $('.ab1_rank2l').find('p')
  result.qs = []
  if (sp.length > 1) {
    let desc = $(sp[1]).text().trim().replace('分类：', '').replace('难易度：', '|').split('|')
    result.cate = desc[0]
    result.level = desc[1]
  }
  for (let i = 2; i < sp.length; i++) {
    let a = $(sp[i])
      .text()
      .trimStart()
      .trimEnd()
      .replace(/选项.+?：/g, '')
    if (a) {
      result.qs.push(a)
    }
  }
  let ap = $('.tiku_answer').find('p')
  if (ap.length > 1) {
    result.answer = $(ap[1])
      .text()
      .replace(/选项.+?：/g, '')
      .replace('、', '')
  } else {
    result.answer = $(ap[0]).text()
  }
  return result
}
