// 10.10.3.10
import config from 'config/config'
import axios from 'axios'

const MAP_NAME = ['准确率', '反应力', '爆发力', '毅力', '亲和力']
const MAP_ID = [99081, 99082, 99083, 99084, 99085]
const MAX_NUM = 100
/**
 * 获取5纬图数据
 * @param {string} accountId
 * @return {Promise<void>}
 */
export async function abilityMap(accountId: string) {
  const url = `${config.susuHost}/item_info?account_id=${accountId}`
  return axios.get(url).then(res => {
    const { data } = res
    const { msg } = data
    const results: any[] = []
    let i = 0
    for (const id of MAP_ID) {
      let val = msg[`item_${id}`] || 0
      results.push({ id: i, name: MAP_NAME[i++], score: val, max: MAX_NUM })
    }
    return results
  })
}

/**
 * 获取总的统计数据
 * @param {string} accountId
 * @return {Promise<void>}
 */
export async function totalStatic(accountId: string) {
  const url = `${config.susuHost}/fight_info?account_id=${accountId}`
  return axios.get(url).then(res => {
    const { data } = res
    const { msg } = data
    const countTotal = msg['total_answer'] || 0
    const countRight = msg['win'] || 0
    const total = msg['total_session'] || 0
    return {
      rightCount: countRight, // 对的
      errorCount: countTotal - countRight, // 错误
      singleCount: total, //total场数
    }
  })
}
